<?php
// @codingStandardsIgnoreStart
/**
 * Plugin Name: WooCommerce Prices By User Role
 * Plugin URI: https://www.persianscript.ir
 * Description:  With this plugin  for WooCommerce  Products can be offered different prices for each customer group. Also you can do only product catalog without prices and show custom notification instead price.
 * Version: 5.2.1
 * Author: پرشین اسکریپت
 * Author URI: https://www.persianscript.ir
 * License: GPL2
 * License URI: https://www.gnu.org/licenses/gpl-2.0.html
 * Text Domain: festi_user_role_prices
 * Domain Path: /languages
 * Requires PHP: 7.4.0
 * WC requires at least: 3.0.0
 * WC tested up to: 4.2
 * Copyright 2014  Plugiton  https://plugiton.com/
 */
// @codingStandardsIgnoreEnd

use engine\EngineError;

try {
    $pluginPath = __DIR__.DIRECTORY_SEPARATOR;

    require_once $pluginPath.'vendor'.DIRECTORY_SEPARATOR.'autoload.php';
    require_once $pluginPath.'config.php';
    require_once $pluginPath.'functions.php';

    WooUserRolePricesUtils::doCheckPhpVersion(PRICE_BY_ROLE_MIN_PHP_VERSION);

    EngineFacade::getInstance()->addActionListener(
        EngineFacade::ACTION_SYSTEM_ERROR,
        function (EngineError $event) {
            return WooUserRolePricesUtils::handleSystemError($event, __FILE__);
        }
    );

    $GLOBALS[PRICE_BY_ROLE_PLUGIN_GLOBAL_NAME] = new WooUserRolePricesFestiPlugin(__FILE__);

    FestiCoreStandalone::init(
        array(
            Core::OPTION_PLUGINS_PATH => PRICE_BY_ROLE_PLUGINS_PATH
        )
    );

} catch (Exception $e) {
    if (FestiCoreStandalone::isInit()) {
        WooUserRolePricesUtils::displayPluginError($e->getMessage());
    } else {
        throw $e;
    }
}
