<?php

/**
 * Plugin Name: Import for Prices by User Role
*/

class WooImportProductsPlugin extends DisplayPlugin
{
    private $_ecommercePlugin;
    private $_ecommerceFacade;

    /**
     * @override
     */
    public function onInit()
    {
        parent::onInit();

        $this->_ecommercePlugin = $GLOBALS[PRICE_BY_ROLE_PLUGIN_GLOBAL_NAME];

        $this->_ecommerceFacade = EcommerceFactory::getInstance();

        EngineFacade::getInstance()->addActionListener(
            'wp_ajax_importProductData',
            array($this, 'onAjaxImportChunkOfProductsAction')
        );
    } // end onInit

    public function displayImportPage($backend)
    {
        $importManager = new CsvWooProductsImporter($backend);

        $importManager->displayPage();
    } // end displayImportPage

    public function onAjaxImportChunkOfProductsAction()
    {
        $backend = $this->_ecommercePlugin->onBackendInit();

        $importManager = new CsvWooProductsImporter($backend);

        $importManager->onAjaxImportChunkOfProductsAction();
    } // end onAjaxImportChunkOfProductsAction
}