<?php

class Logger
{
    public static $path = null;
    
    public static function info(string $message): void
    {
        self::addMessage($message, 'info');
    }
    
    public static function debug(string $message): void
    { 
        self::addMessage($message, 'debug');
    }
    
    public static function addMessage(string $msg, string $type = 'debug', ?string $file = null): void
    {
        if (is_null(self::$path)) {
            return;
        }

        $file = $file ? $file : 'logger';
        
        $msg = sprintf("%s\t[%s]\t%s\n", date('Y-m-d H:i:s'), $type, $msg);

        error_log($msg, 3, self::$path.'/'.$file.".log");
    }
    
    public static function access(): void
    {
        self::addMessage(join("\t", func_get_args()), __FUNCTION__);
    }
    
    public static function error(string $msg, int $code = 0): void
    {
        $debug = debug_backtrace();
        
        $msg .= "\t{".$code."}";
        
        if (!empty($debug[1])) {
            if (!empty($debug[1]['file'])) {
                $msg .= "\n".$debug[1]['file'].":".$debug[1]['line']." ".$debug[1]['class'].
                        "::".$debug[1]['function']."()";
            } else {
                $msg .= "\t".$debug[1]['class']."::".$debug[1]['function']."()";
            }
        }

        self::addMessage($msg, __FUNCTION__, "errors");
    }
}
