<?php

class LocaleModel
{
    /** @var IDictionaryLocale */
    private $_dictionary;
    
    public function __construct(IDictionaryLocale $dictionary)
    {
        $this->_dictionary = $dictionary;

        $this->_dictionary->load();
    }

    public function get(string $key): string
    {
        return $this->_dictionary->get($key) ?? $key;
    }

    public function getPlural(string $idMessage, string $messagePlural, int $count): string
    {
        $word = $this->_dictionary->getPlural($idMessage, $messagePlural, abs($count));
        if (is_null($word)) {
            $word = $messagePlural;
            if (abs($count) === 1) {
                $word = $idMessage;
            }
        }

        return $word;
    }
}
