<?php

class MoReader
{
    private $_file;

    public function __construct(string $fileName)
    {
        $this->_file = fopen($fileName, 'rb');
    }

    /**
     * @param int $bytes
     * @return string|false
     */
    public function read(int $bytes)
    {
        return fread($this->_file, $bytes);
    }

    public function seekto(int $offset): bool
    {
        $result = fseek($this->_file, $offset);

        return $result !== -1;
    }

    public function isResource(): bool
    {
        return is_resource($this->_file);
    }

    public function feof(): bool
    {
        return feof($this->_file);
    }

    public function close(): bool
    {
        return fclose($this->_file);
    }

    public function readAll(): string
    {
        $all = array();
        while (!$this->feof()) {
            $all[] = $this->read(4096);
        }

        return implode('', $all);
    }
}
