<?php

use \core\store\IStore;

class StagePlugin extends DisplayPlugin
{
    private $_stage;

    public function __construct()
    {
        parent::__construct();
    
        $this->_stage = new StageBuilder(2, StageBuilder::LAYOUT_ROWS);
    } // end __construct
    
    public function setSize(int $size): void
    {
        $this->_stage->setSize($size);
    }
    
    public function setLayout(string $layout): void
    {
        $this->_stage->setLayout($layout);
    }
    
    public function addBlock($instance, int $size = 1, ?string $className = null): int
    {
        return $this->_stage->addBlock($instance, $size, $className);
    } // end addBlock
    
    public function addStoreBlock(IStore $store, int $size = 1): int
    {
        return $this->_stage->addStoreBlock($store, $size);
    } // end addStoreBlock
    
    public function addStoreActionBlock(AbstractDisplayAction $store, int $size = 1): int
    {
        return $this->_stage->addStoreActionBlock($store, $size);
    } // end addStoreActionBlock
    
    public function addCallbackBlock(
        $callback, ?array $externalParams = null, int $size = 1
    ): int
    {
        return $this->_stage->addCallbackBlock(
            $callback, 
            $externalParams, 
            $size
        );
    } // end addCallbackBlock
    
    public function addUrlBlock(string $url, int $size = 1): int
    {
        return $this->_stage->addUrlBlock($url, $size);
    } // end addUrlBlock
    
    public function onRequest(Response &$response)
    {
        return $this->_stage->onRequest($response);
    } // end onRequest
}