<?php

namespace core\store;

use Entity;
use Response;
use StoreModel;
use AbstractAction;

abstract class AbstractStore extends Entity implements IStore
{
    abstract protected function getStoreInstance(): IStore;

    public function &getModel(): StoreModel
    {
        return $this->getStoreInstance()->getModel();
    }

    public function createActionInstance(string $action): AbstractAction
    {
        return $this->getStoreInstance()->createActionInstance($action);
    }

    public function getActionNameFromRequest(): string
    {
        return $this->getStoreInstance()->getActionNameFromRequest();
    }

    public function onRequest(Response &$response): bool
    {
        return $this->getStoreInstance()->onRequest($response);
    }
}
