<?php

namespace core\store\event;

use core\store\field\IStoreField;

class StoreFieldEvent extends \FestiEvent
{
    const EVENT_ON_GET_EDIT_VIEW = "on_get_edit_field";

    public function &getField(): IStoreField
    {
        return $this->getTargetValueByKey('field');
    } // end getField

    public function &getContent(): ?string
    {
        return $this->getTargetValueByKey('content');
    } // end getContent
    
    /**
     * @suppress PhanTypeArraySuspicious
     * @param string $content
     * @return void
     */
    public function setContent(string $content): void
    {
        $this->target['content'] = $content;
    } // end setContent

    public function &getValue()
    {
        return $this->getTargetValueByKey('value');
    } // end getValue
}