<?php

class CompositeField  extends AbstractField
{
    public const VALUES_SEPARATOR = '|';

    protected array $options = array();

    /**
     * @override
     */
    public function onInit(FieldModel $scheme): void
    {
        parent::onInit($scheme);

        $this->onInitOptions($scheme);
    } // end onInit

    /**
     * @override
     */
    protected function onInitOptions($scheme): void
    {
        $this->options = $scheme->getOptions();

        $this->set('onlyList', true);
        $this->set('sorting', 'false');
        //$this->set('filter', false);
    } // end onInitOptions

    public function getOptions(): array
    {
        return $this->options;
    }

    /**
     * @override
     */
    public function displayValue(?string $value, array $row = array()): ?string
    {
        if (!$value) {
            return '';
        }

        $chunks = explode(static::VALUES_SEPARATOR, $value);
        $values = array();
        foreach ($chunks as $item) {
            list($key, $itemValue) = explode(':', $item);
            $values[$key] = $itemValue;
        }

        $format = $this->get('format');
        if ($format) {
            return Entity::fillString($format, $values);
        }

        $separator = $this->get('separator');
        if (!$separator) {
            $separator = ' ';
        }

        return join($separator, $values);
    } // end displayValues
}
