<?php

namespace core\store\field;

interface IStoreForeignField extends IStoreField
{
    /**
     * Returns foreign store name.
     *
     * @return string
     */
    public function getForeignStoreName(): string;

    /**
     * Returns foreign table name (with alias).
     *
     * @return string
     */
    public function getForeignTable(): string;

    /**
     * Returns key for foreign field.
     *
     * @return string
     */
    public function getForeignFieldKey(): string;

    /**
     * Returns value for foreign field.
     *
     * @return string
     */
    public function getForeignFieldValue(): string;

    /**
     * Set list of values.
     *
     * @param array $values
     */
    public function setValuesList(array $values): void;

    /**
     * Returns list of values.
     *
     * @return array
     */
    public function getValuesList(): array;

    /**
     * Returns true if we have to ignore a default logic to load values.
     *
     * @override
     * @return bool
     */
    public function isCustomLoadValues(): bool;

    public function getValuesWhere(): ?string;
}
