<?php

class TimestampField extends DatetimeField
{
    /**
     * @override
     */
    public function getFormattedValue($value): ?string
    {
        $format = $this->getFormat();

        if (!empty($value)) {
            $value = strftime($format, $value);
        }

        return $value;
    } // end getFormattedValue

    /**
     * @override
     */
    public function getValue(array $request = array())
    {
        $value = parent::getValue($request);

        if (!$value && isset($this->attributes['isnull'])) {
            $value = null;
            return $value;
        }

        return strtotime($value);
    } // end getValue

    protected function getPreparedValueForEdit($value, $format)
    {
        return strftime($format, $value);
    } // end getPreparedValueForEdit

    /**
     * @override
     */
    public function displayRO($value): ?string
    {
        if ($value) {
            $format = $this->getFormat();
            $value = strftime($format, $value);
        }

        return $value;
    } // end displayRO
}