<?php

use core\store\field\IStoreForeignField;

trait ForeignKeyProxy
{
    /**
     * Call plugin callback to override load ForeignKey field values.
     *
     * @param Store $store
     * @param IStoreForeignField $field
     * @param array $info
     */
    protected function firePrepareStoreForeignKeyFieldValuesCallback(
        Store &$store, IStoreForeignField &$field, array &$info
    ): void
    {
        $event = new FestiEvent(Store::EVENT_ON_PROXY_PREPARE_FOREIGN_KEY_VALUES, $info);
        $this->store->dispatchEvent($event);

        $plugin = $this->store->getPlugin();

        if ($plugin && $plugin instanceof IStoreProxyForeignKeyValuesListener) {
            $plugin->onPrepareStoreForeignKeyFieldValues($store, $field, $info);
        }
    }
}
