<?php

trait SqlConditionsProxy
{
    abstract public function &getConnection(): IDataAccessObject;

    public function getLikeCondition(
        string $column,
        string $value,
        bool $caseSensitive = false,
        bool $isNotClause = false
    ): array
    {
        $operator = $this->_getLikeOperator($caseSensitive);

        $columnExpression = $column.'&';
        $columnExpression .= $isNotClause ? 'NOT ' : '';
        $columnExpression .= $operator;

        return array($columnExpression => $value);
    }

    private function _getLikeOperator(bool $caseSensitive): string
    {
        $type = $this->getConnection()->getDatabaseType();

        switch ($type) {
            case DataAccessObject::TYPE_MYSQL:
                return $caseSensitive ? 'LIKE BINARY' : 'LIKE';
                break;

            case DataAccessObject::TYPE_PGSQL:
                return  $caseSensitive ? 'LIKE' : 'ILIKE';
                break;
        }

        return 'LIKE';
    }
}
