<?php

class Bundle_CoreTest extends FestiTestCase
{

    public function testGetInstanceWithoutOptions()
    {
        $core = Core::getInstance();
        $this->assertNotNull($core);
    } // end testGetInstanceWithoutOptions
    
    public function testCreateStoreInstanceByXmlModel()
    {
        $core = $this->getCoreWithConnection();
        $store = $core->createStoreInstance(STORE_DEFAULT);
        
        $this->assertNotNull($store);
    } // end testGetInstanceWithoutOptions


    public function testExec()
    {
        $str = 'test str ()"`{}#!?*';
        $cmd = 'echo '.$str;
        
        $core = Core::getInstance();

        $res = $core->exec($cmd);    
        
        $this->assertEquals($res, $str);
    } // end testExec

    public function testPluginsCalls()
    {
        $testPlugin = $this->core->getPluginInstance('Test');
        $this->assertNotNull($testPlugin);

        $expectedValue = $testPlugin->getValueForTestWrapper();
        $this->assertTrue($expectedValue > 0);

        $secondPlugin = $this->core->getPluginInstance('Second');
        $this->assertNotNull($secondPlugin);

        $value = $secondPlugin->getValueFromTestPlugin();

        $this->assertTrue($value == $expectedValue);
    }
    
    public function testPluginsCallsByClassName()
    {
        $testPlugin = $this->core->getPluginInstance(TestPlugin::class);
        $this->assertNotNull($testPlugin);
        
        $this->assertEquals('Test', $testPlugin->getOption('name'));
    }
}
