<?php

namespace tests\Bundle\Store\Action;

use FestiTestCase;
use PluginAction;
use Response;
use Store;

class PluginActionTest extends FestiTestCase
{
    public function testOnStart(): void
    {
        $core = $this->getCoreWithConnection();

        $store = $core->createStoreInstance(STORE_DEFAULT);

        $action = $store->createActionInstance(Store::ACTION_PLUGIN);

        $this->assertInstanceOf(PluginAction::class, $action);

        $response = new Response();

        $this->assertObjectNotHasAttribute('content', $response);

        $action->onStart($response);

        $this->assertObjectHasAttribute('content', $response);

        $this->assertTrue((bool) $response->content);
    } // end testOnStart
}