<?php

namespace tests\Bundle\Store\Field;

use Core;
use FestiTestCase;
use Response;
use Store;

class HandlerFieldTest extends FestiTestCase
{
    public function testFieldColumnNameErrorInEditForm(): void
    {
        $options = array();

        $options['model'] = array(
            'table' => array(
                'name'       => 'site_contents',
                'primaryKey' => 'id',
                'exceptionMode' => true
            ),

            'fields' => array(
                'value' => array(
                    'type' => 'handler',
                    'name' => 'name',
                    'caption' => 'Value',
                    'plugin' => 'Test',
                    'hide'  => true
                )
            ),
            'actions' => array(
                Store::ACTION_LIST => array(
                    'type' => Store::ACTION_LIST,
                    'caption' => 'List'
                ),
                Store::ACTION_INSERT => array(
                    'type' => Store::ACTION_INSERT,
                    'caption' => 'Add'
                ),
                Store::ACTION_EDIT => array(
                    'type' => Store::ACTION_EDIT,
                    'caption' => 'Edit'
                )
            )
        );
        

        $store = Core::getInstance()->createStoreInstance(
            'site_contents',
            $options
        );
        
        $response = new Response();
        
        $action = $store->createActionInstance(Store::ACTION_EDIT);
        $action->onStart($response);
        $this->assertNotEmpty($response->getContent());
    }
}
