<?php

namespace tests\Bundle\Store\Field;

use Core;
use FestiTestCase;
use Response;
use Store;

class Md5FieldTest extends FestiTestCase
{
    public function testListView(): void
    {
        $options = array();

        $options['model'] = array(
            'table' => array(
                'name'       => 'site_contents',
                'primaryKey' => 'id',
                'exceptionMode' => true
            ),

            'fields' => array(
                'value' => array(
                    'type' => 'md5',
                    'name' => 'name',
                    'caption' => 'Value'
                )
            ),
            'actions' => array(
                Store::ACTION_LIST => array(
                    'type' => Store::ACTION_LIST,
                    'caption' => 'List'
                ),
                Store::ACTION_INSERT => array(
                    'type' => Store::ACTION_INSERT,
                    'caption' => 'Add'
                )
            )
        );

        $store = Core::getInstance()->createStoreInstance(
            'site_contents',
            $options
        );

        //
        $action = $store->createActionInstance(Store::ACTION_INSERT);


        $values = array(
            'name' => 'TEST'
        );

        FestiTestCase::preparePostForStore($action, $values, $store);

        $response = new Response();
        $action->onStart($response);

        $this->assertNotEmpty($response->notifications);

        //
        $action = $store->createActionInstance(Store::ACTION_LIST);

        $response = new Response();
        $action->onStart($response);

        $this->assertNotEmpty($response->getContent());
    }
}
