<?php

namespace tests\Bundle\Store\Field;

use Core;
use FestiTestCase;
use Response;
use Store;

class NumberFieldTest extends FestiTestCase
{
    public function testAttributesInForm(): void
    {
        $store = $this->_getStore();

        $action = $store->createActionInstance(Store::ACTION_INSERT);
        $response = new Response();

        $action->onStart($response);

        $this->assertMatchesRegularExpression(
            "#<input type=\"number\" id=\"cost\"[^>]+".
            "min=\"10\" step=\"0\.1\"[^>]+\/>#Umis",
            $response->getContent(),
            "Not found insert form."
        );
    }

    private function _getStore(): Store
    {
        $options = array();

        $options['model'] = array(
            'table' => array(
                'name'          => 'site_contents',
                'primaryKey'    => 'id',
                'exceptionMode' => true
            ),

            'fields' => array(
                'value' => array(
                    'type'    => 'number',
                    'name'    => 'cost',
                    'caption' => 'Cost',
                    'min'     => '10',
                    'step'    => '0.1',
                )
            ),
            'actions' => array(
                Store::ACTION_LIST => array(
                    'type' => Store::ACTION_LIST,
                    'caption' => 'List'
                ),
                Store::ACTION_INSERT => array(
                    'type' => Store::ACTION_INSERT,
                    'caption' => 'Add'
                )
            )
        );

        $store = Core::getInstance()->createStoreInstance(
            'site_contents',
            $options
        );

        return $store;
    }
}
