<?php

namespace tests\Bundle\Store\Field;

use Core;
use FestiTestCase;
use Response;
use Store;

class PasswordFieldTest extends FestiTestCase
{
    public function testViewTypeField(): void
    {
        $options = array();
        
        $options['model'] = array(
            'table' => array(
                'name'          => 'site_contents',
                'primaryKey'    => 'id',
                'exceptionMode' => true
            ),
            
            'fields' => array(
                'value' => array(
                    'type'    => 'password',
                    'name'    => 'testPassword',
                    'caption' => 'Value'
                )
            ),
            'actions' => array(
                Store::ACTION_LIST => array(
                    'type' => Store::ACTION_LIST,
                    'caption' => 'List'
                ),
                Store::ACTION_INSERT => array(
                    'type' => Store::ACTION_INSERT,
                    'caption' => 'Add'
                )
            )
        );
        
        $store = Core::getInstance()->createStoreInstance(
            'site_contents',
            $options
        );
        
        $action = $store->createActionInstance(Store::ACTION_INSERT);
        
        $response = new Response();
        $action->onStart($response);
        
        $this->assertNotEmpty($response->getContent());
        
        $this->assertMatchesRegularExpression(
            "#type=\"password\" id=\"testPassword\"#Umis",
            $response->getContent()
        );
    }
}
