<?php

namespace tests\Bundle\Store\Field;

use Core;
use FestiTestCase;
use Response;
use Store;

class PercentFieldTest extends FestiTestCase
{
    public function testPercentInForm(): void
    {
        $store = $this->_getStore();

        $action = $store->createActionInstance(Store::ACTION_INSERT);
        $response = new Response();

        $action->onStart($response);

        $this->assertMatchesRegularExpression(
            "#<input .* name=\"threshold\".*value=\"0\"#Umis",
            $response->getContent(),
            "Not found input in insert form."
        );
    }

    private function _getStore(): Store
    {
        $options = array();

        $options['model'] = array(
            'table' => array(
                'name'          => 'site_contents',
                'primaryKey'    => 'id',
                'exceptionMode' => true
            ),

            'fields'  => array(
                'value' => array(
                    'type'    => 'percent',
                    'name'    => 'threshold',
                    'caption' => 'threshold',
                )
            ),
            'actions' => array(
                Store::ACTION_LIST   => array(
                    'type'    => Store::ACTION_LIST,
                    'caption' => 'List'
                ),
                Store::ACTION_INSERT => array(
                    'type'    => Store::ACTION_INSERT,
                    'caption' => 'Add'
                )
            )
        );

        $store = Core::getInstance()->createStoreInstance(
            'site_contents',
            $options
        );

        return $store;
    }
}
