<?php

namespace tests\Bundle\Store\Field;

use Core;
use FestiTestCase;
use Response;
use Store;

class PriceFieldTest extends FestiTestCase
{
    public function testCurrencyInForm(): void
    {
        $store = $this->_getStore();

        $action = $store->createActionInstance(Store::ACTION_INSERT);
        $response = new Response();

        $action->onStart($response);

        $this->assertMatchesRegularExpression(
            "#<span class=\"input-group-addon ".
            "input-group-currency\">\\$<\/span>#Umis",
            $response->content,
            "Not found insert form."
        );
    }

    private function _getStore(): Store
    {
        $options = array();

        $options['model'] = array(
            'table' => array(
                'name'       => 'site_contents',
                'primaryKey' => 'id',
                'exceptionMode' => true
            ),

            'fields' => array(
                'value' => array(
                    'type' => 'price',
                    'name' => 'cost',
                    'caption' => 'Cost',
                )
            ),
            'actions' => array(
                Store::ACTION_LIST => array(
                    'type' => Store::ACTION_LIST,
                    'caption' => 'List'
                ),
                Store::ACTION_INSERT => array(
                    'type' => Store::ACTION_INSERT,
                    'caption' => 'Add'
                )
            )
        );

        $store = Core::getInstance()->createStoreInstance(
            'site_contents',
            $options
        );

        return $store;
    }
}
