<?php

namespace tests\Bundle\Store;

use FestiTestCase;
use ListAction;
use Response;
use Store;

class RoutersTest extends FestiTestCase
{
    private function _testListDataByRoutes($storeName): void
    {
        $core = $this->getCoreWithConnection();

        $expectedName = 'Test';
        $values = array(
            'status' => 'active',
            'ident'  => $expectedName
        );

        $core->db->insert('festi_plugins', $values);

        $values = array(
            'pattern' => 'pattern',
            'method'  => 'method',
            'plugin'  => $expectedName
        );

        $core->db->insert('festi_url_rules', $values);

        $store = $core->createStoreInstance($storeName);

        $store->setOption('storeExceptionMode', true);

        $action = $store->createActionInstance(Store::ACTION_LIST);

        $this->assertInstanceOf(ListAction::class, $action);

        // Aggregate Function column
        $response = new Response();
        $action->onStart($response);
        $values = $action->getValues();

        $this->assertTrue(count($values) == 1);
        list($row) = $values;
        $this->assertTrue($row['ident'] == $expectedName);
    } // end _testListDataByRoutes

    public function testJoinAttributeInStore(): void
    {
        $this->_testListDataByRoutes('dgs_join');
    }

    public function testRoutesInStore(): void
    {
        $this->_testListDataByRoutes('dgs_routers');
    }
}
