USE festi_tests;

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[settings]') AND type in (N'U'))
    DROP TABLE [dbo].[settings];

CREATE TABLE [dbo].[settings](
    [id] [int] IDENTITY(1,1) NOT NULL,
    [caption] [varchar](128) NULL,
    [value] [varchar](255) NULL,
    [id_parent] [int] NULL,
    [id_parent_setting] [int] NULL,
    [amount] [float] NULL,
    CONSTRAINT [PK_settings] PRIMARY KEY CLUSTERED ([id] ASC)
    WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON)
    ON [PRIMARY]
) ON [PRIMARY];


IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[site_contents]') AND type in (N'U'))
    DROP TABLE [dbo].[site_contents];

CREATE TABLE [dbo].[site_contents](
    [id] [int] IDENTITY(1,1) NOT NULL,
    [id_parent] [int] NULL,
    [name] [varchar](128) NULL,
    [cdate] [DATETIME] NULL,
    [mdate] [DATETIME] NULL,
    CONSTRAINT [PK_site_contents] PRIMARY KEY CLUSTERED ([id] ASC)
    WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON)
    ON [PRIMARY]
) ON [PRIMARY];


IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[site_contents2settings]') AND type in (N'U'))
    DROP TABLE [dbo].[site_contents2settings];

CREATE TABLE [dbo].[site_contents2settings](
                                               [id] [int] IDENTITY(1,1) NOT NULL,
                                               [id_site_content] [int],
                                               [id_setting] [int],
                                               [value] [int],
                                               CONSTRAINT [PK_site_contents2settings] PRIMARY KEY CLUSTERED
                                                   (
                                                    [id] ASC
                                                       )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY];

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[dgs_test_table]') AND type in (N'U'))
    DROP TABLE [dbo].[dgs_test_table];

CREATE TABLE [dbo].[dgs_test_table](
                                       [id] [int] IDENTITY(1,1) NOT NULL,
                                       [caption] [VARCHAR](128),
                                       [value] [VARCHAR](128),
                                       [is_used] [bit],
                                       [id_param] [int],
                                       [id_child_param] [int],
                                       [status] [varchar](10)  NULL CHECK (status IN('active','pause','pending')),
                                       CONSTRAINT [PK_dgs_test_table] PRIMARY KEY CLUSTERED
                                           (
                                            [id] ASC
                                               )WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON) ON [PRIMARY]
) ON [PRIMARY];


IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[queue_simple]') AND type in (N'U'))
    DROP TABLE [dbo].[queue_simple];

CREATE TABLE [dbo].[queue_simple](
    [id] [int] IDENTITY(1,1) NOT NULL,
    [data] [VARCHAR](128),
    [error] [VARCHAR](256),
    [id_worker] [int],
    CONSTRAINT [PK_queue_simple] PRIMARY KEY CLUSTERED ([id] ASC)
    WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON)
    ON [PRIMARY]
) ON [PRIMARY];

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[cron_workers]') AND type in (N'U'))
    DROP TABLE [dbo].[cron_workers];

CREATE TABLE [dbo].[cron_workers](
    [id] [int] IDENTITY(1,1) NOT NULL,
    [data] [VARCHAR](128),
    [error] [VARCHAR](256),
    [status] [VARCHAR](128),
    [id_worker] [int],
    CONSTRAINT [PK_cron_workers] PRIMARY KEY CLUSTERED ([id] ASC)
    WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON)
    ON [PRIMARY]
) ON [PRIMARY];


IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[festi_plugins]') AND type in (N'U'))
    DROP TABLE [dbo].[festi_plugins];

CREATE TABLE [dbo].[festi_plugins](
    [id] [int] IDENTITY(1,1) NOT NULL,
    [status] [VARCHAR](128),
    [ident] [VARCHAR](256),
    [version] [VARCHAR](128),
    CONSTRAINT [PK_festi_plugins] PRIMARY KEY CLUSTERED ([id] ASC)
    WITH (PAD_INDEX  = OFF, STATISTICS_NORECOMPUTE  = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS  = ON, ALLOW_PAGE_LOCKS  = ON)
    ON [PRIMARY]
) ON [PRIMARY];

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[festi_url_rules]') AND type in (N'U'))
    DROP TABLE [dbo].[festi_url_rules];

CREATE TABLE [dbo].[festi_url_rules](
	[plugin] [varchar](32) NOT NULL,
	[pattern] [varchar](255) NOT NULL,
	[method] [varchar](64) NOT NULL,
	[id] [int] IDENTITY(1,1) NOT NULL,
 CONSTRAINT [PK_festi_url_rules] PRIMARY KEY CLUSTERED
(
	[id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY];


IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[festi_url_rules2areas]') AND type in (N'U'))
    DROP TABLE [dbo].[festi_url_rules2areas];

CREATE TABLE [dbo].[festi_url_rules2areas](
	[id_url_rule] [int] NULL,
	[area] [varchar](32) NULL,
	[id] [int] IDENTITY(1,1) NOT NULL,
 CONSTRAINT [PK_festi_url_rules2areas] PRIMARY KEY CLUSTERED
(
	[id] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY];
