CREATE TABLE IF NOT EXISTS `settings`
(
  `id`        int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id_parent` int(11) unsigned DEFAULT NULL,
  `id_parent_setting` int(11) unsigned DEFAULT NULL,
  `caption`   varchar(128)     DEFAULT NULL,
  `value`     varchar(255)     DEFAULT NULL,
  `amount` int(11) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE = InnoDB DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `site_contents`
(
  `id`        int(11) unsigned NOT NULL AUTO_INCREMENT,
  `id_parent` int(11) unsigned DEFAULT NULL,
  `name`      varchar(255)     DEFAULT NULL,
  `cdate`     DATETIME         NULL,
  `mdate`     DATETIME         NULL,
  PRIMARY KEY (`id`)
) ENGINE = InnoDB DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `site_contents2settings`
(
  `id`              int(11) unsigned NOT NULL AUTO_INCREMENT,
  `id_site_content` int(11) unsigned  NOT NULL,
  `id_setting`      int(11) unsigned  NOT NULL,
  `value`      int(11) unsigned  NULL,
  PRIMARY KEY (`id`)
) ENGINE = InnoDB DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `dgs_test_table`
(
  `id`       int(11) unsigned NOT NULL AUTO_INCREMENT,
  `caption`  varchar(256)     NULL DEFAULT NULL,
  `value`    text             NULL DEFAULT NULL,
  `is_used`  int(1)           NOT NULL,
  `id_param` int(11) unsigned NULL DEFAULT NULL,
  `id_child_param` int(11) unsigned NULL DEFAULT NULL,
  `status`   enum ('active','pause','pending'),
  PRIMARY KEY (`id`)
) ENGINE = InnoDB DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `festi_plugins`
(
  `id`      int(10) unsigned         NOT NULL AUTO_INCREMENT,
  `status`  enum ('active','hidden') NOT NULL DEFAULT 'active',
  `ident`   varchar(32)              NOT NULL,
  `version` int(5)                   DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `ident` (`ident`),
  UNIQUE KEY `ident_2` (`ident`)
) ENGINE = InnoDB DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `festi_url_areas`
(
  `id`    int(10) unsigned NOT NULL AUTO_INCREMENT,
  `ident` varchar(32)      NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `ident` (`ident`)
) ENGINE = InnoDB DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `festi_url_rules`
(
  `id`      int(10) unsigned NOT NULL AUTO_INCREMENT,
  `plugin`  varchar(32)      NOT NULL,
  `pattern` varchar(255)     NOT NULL,
  `method`  varchar(64)      NOT NULL,
  PRIMARY KEY (`id`),
  KEY `plugin` (`plugin`),
  CONSTRAINT `festi_url_rules_ibfk_1` FOREIGN KEY (`plugin`) REFERENCES `festi_plugins` (`ident`) ON DELETE CASCADE
) ENGINE = InnoDB DEFAULT CHARSET = utf8;

CREATE TABLE IF NOT EXISTS `festi_url_rules2areas`
(
  `id`          int(10) unsigned NOT NULL AUTO_INCREMENT,
  `id_url_rule` int(10) unsigned NOT NULL,
  `area`        varchar(32)      NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id_url_rule` (`id_url_rule`, `area`),
  KEY `area` (`area`),
  CONSTRAINT `festi_url_rules2areas_ibfk_1` FOREIGN KEY (`area`) REFERENCES `festi_url_areas` (`ident`) ON UPDATE NO ACTION
) ENGINE = InnoDB DEFAULT CHARSET = utf8;


INSERT INTO `festi_url_areas` (`ident`) VALUES ('backend');

CREATE TABLE IF NOT EXISTS `queue_simple` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `data` longtext NOT NULL,
  `error` longtext NULL DEFAULT NULL,
  `id_worker` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE IF NOT EXISTS `cron_workers` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `data` text NOT NULL,
  `error` text NULL DEFAULT NULL,
  `status`  varchar(32) NULL DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;





