CREATE TABLE IF NOT EXISTS settings
(
  id serial NOT NULL,
  id_parent int4 DEFAULT NULL,
  id_parent_setting int4 DEFAULT NULL,
  caption text,
  value text,
  amount integer DEFAULT NULL,
  CONSTRAINT settings_pkey PRIMARY KEY (id)
);

CREATE TABLE IF NOT EXISTS site_contents
(
  id serial NOT NULL,
  id_parent integer,
  name text,
  cdate timestamp DEFAULT NULL,
  udate timestamp DEFAULT NULL,
  CONSTRAINT site_contents_pkey PRIMARY KEY (id)
);

CREATE TABLE IF NOT EXISTS site_contents2settings
(
  id serial NOT NULL,
  id_site_content integer,
  id_setting integer,
  value integer DEFAULT NULL,
  CONSTRAINT site_contents2settings_pkey PRIMARY KEY (id)
);

CREATE TYPE dgs_test_table_status AS ENUM ('active','pause','pending');

CREATE TABLE IF NOT EXISTS dgs_test_table (
  id       serial PRIMARY KEY,
  caption  varchar(256) DEFAULT NULL,
  value    text DEFAULT NULL,
  is_used  BOOLEAN NOT NULL,
  id_param int4 DEFAULT NULL,
  id_child_param int4 DEFAULT NULL,
  status dgs_test_table_status
);

CREATE TYPE festi_plugins_status AS ENUM ('active','pause','pending');

CREATE TABLE IF NOT EXISTS festi_plugins
(
  id      serial PRIMARY KEY,
  status  festi_plugins_status NOT NULL DEFAULT 'active',
  ident   varchar(32) NOT NULL,
  version int2 DEFAULT NULL,
  UNIQUE (ident)
);

CREATE TABLE IF NOT EXISTS festi_url_areas
(
  id    serial PRIMARY KEY,
  ident varchar(32) NOT NULL,
  UNIQUE (ident)
);

CREATE TABLE IF NOT EXISTS festi_url_rules
(
  id      serial PRIMARY KEY,
  plugin  varchar(32) NOT NULL,
  pattern varchar(255) NOT NULL,
  method  varchar(64) NOT NULL,
  UNIQUE (plugin),
  CONSTRAINT festi_url_rules_ibfk_1 FOREIGN KEY (plugin) REFERENCES festi_plugins (ident) ON DELETE CASCADE
);

CREATE TABLE IF NOT EXISTS festi_url_rules2areas
(
  id          serial PRIMARY KEY,
  id_url_rule int4 NOT NULL,
  area        varchar(32) NOT NULL,
  UNIQUE (id_url_rule, area),
  UNIQUE (area),
  CONSTRAINT festi_url_rules2areas_ibfk_1 FOREIGN KEY (area) REFERENCES festi_url_areas (ident) ON UPDATE NO ACTION
);

INSERT INTO festi_url_areas (ident) VALUES ('backend');

CREATE TABLE IF NOT EXISTS queue_simple (
  id serial,
  data text NOT NULL,
  error text NULL DEFAULT NULL,
  id_worker int check (id_worker > 0) DEFAULT NULL,
  PRIMARY KEY (id)
) ;

CREATE TABLE IF NOT EXISTS cron_workers (
  id serial,
  data text NOT NULL,
  error text NULL DEFAULT NULL,
  status text NULL DEFAULT NULL,
  PRIMARY KEY (id)
);
