<?php

class TestPlugin extends DisplayPlugin
{
    public function onDisplayDefault(Response $response)
    {
        $response->content = true;
    
        return true;
    }
    
    public function onValidateFileField(AbstractField &$field, $value)
    {
        if (!$this->_isValidFileExtension($value)) {
            $msg = __('Invalid File Extension');
            $field->setErrorMessage($msg);
            return false;
        }
    
        return true;
    }
    
    public function getNameFieldValue(AbstractField &$field, $value)
    {
        return $value;
    }
    
    public function getNameFieldEditInput(AbstractField &$field, $value)
    {
    
    }
    
    public function getNameFieldColumnName()
    {
        return 'name';
    }

    private function _isValidFileExtension($fileInfo)
    {
        $allowedExtensions = array('png');
        $extension         = $this->_getFileExtension($fileInfo);
        
        return in_array($extension, $allowedExtensions);
    }

    private function _getFileExtension($fileInfo)
    {
        $regex = '#^.*\.(?P<extension>[a-z]{2,4});0;#Um';
    
        if (!preg_match($regex, $fileInfo, $match)) {
            $message = __('Parse File Extension Fail');
            throw new SystemException($message);
        }
    
        return $match['extension'];
    }
    
    public function getValueForTestWrapper()
    {
        return 5;
    }
}