<?php

namespace core\orm;

use Throwable;

class EntityFieldException extends EntityException
{
    protected string $fieldName;

    public function __construct(
        string $fieldName,
        string $message = "",
        int $code = 0,
        ?Throwable $previous = null
    )
    {
        $this->fieldName = $fieldName;
        if (!$message) {
            $message = "Unavailable value for column ".$fieldName;
        }

        parent::__construct($message, $code, $previous);
    }

    public function getFieldName(): string
    {
        return $this->fieldName;
    }

}