<?php

class DatabaseTestCase extends PHPUnit\Framework\TestCase
{
    protected function createConnection(): IDataAccessObject
    {
        $db = new PDO("sqlite:".__DIR__."/tests.db");

        // Move to bootstrap
        $content = file_get_contents(__DIR__.DIRECTORY_SEPARATOR.'dump.sql');
        $queries = array_filter(explode(";", $content));

        $connection = DataAccessObject::factory($db);
        foreach ($queries as $query) {
            $connection->query($query);
        }

        return $connection;
    }

}