<?php

use ui\IButton;

/**
 * Class ButtonHui.
 */
class ButtonHui extends HuiComponent implements IButton
{
    public const TYPE_SUBMIT = 'submit';
    public const TYPE_RESET  = 'reset';
    public const TYPE_BUTTON = 'button';
    
    public function setCaption(string $caption): IButton
    {
        $this->view->caption = $caption;

        return $this;
    }

    public function setUrl(string $url): IButton
    {
        $this->view->url = $url;

        return $this;
    }

    public function setId(string $id): IButton
    {
        $this->view->id = $id;

        return $this;
    }

    public function setCSS(string $css): IButton
    {
        $this->view->css = $css;

        return $this;
    }
    
    public function setType(string $type): IButton
    {
        $this->view->type = $type;
        
        return $this;
    }
    
    public function getType(): ?string
    {
        if (!isset($this->view->type)) {
            return null;
        }
        
        return $this->view->type;
    }
}