<?php

use ui\IDialog;
use ui\IInput;

/**
 * Class DialogHui.
 */
class DialogHui extends HuiComponent implements IDialog
{
    public function setTitle(string $title): IDialog
    {
        $this->view->title = $title;

        return $this;
    }

    public function setSubmitCaption(string $caption): IDialog
    {
        $this->view->submitCaption = $caption;

        return $this;
    }

    public function setBody(string $body): IDialog
    {
        $this->view->body = $body;

        return $this;
    }

    public function setUrl(string $url): IDialog
    {
        $this->view->url = $url;

        return $this;
    }

    public function setId(string $id): IDialog
    {
        $this->view->id = $id;

        return $this;
    }

    public function setCloseCaption(string $caption): IDialog
    {
        $this->view->closeCaption = $caption;

        return $this;
    }

    public function setHidden(bool $isHidden): IDialog
    {
        $this->view->isHidden = $isHidden;

        return $this;
    }

    public function addField(string $name, IInput $field): IDialog
    {
        if (!isset($this->view->field)) {
            $this->view->field = array();
        }

        $this->view->field[$name] = $field;

        return $this;
    }
    
    public function addHiddenField(string $key, IInput $field): IDialog
    {
        if (!isset($this->view->hiddenFields)) {
            $this->view->hiddenFields = array();
        }

        $this->view->hiddenFields[$key] = $field;

        return $this;
    }

    public function setCSS(string $css): IDialog
    {
        $this->view->css = $css;

        return $this;
    }
}