<?php

class HuiComponent
{
    protected $parent;
    protected $arguments;
    protected $templateName;

    public $view;

    public function __construct($parent = false, $arguments = false)
    {
        $this->parent = $parent;
        $this->arguments = $arguments;
    }

    public function getCSS(): string
    {
        if (!isset($this->view->css)) {
            return '';
        }

        return $this->view->css;
    }

    /**
     * @param $name
     * @param $arguments
     * @return $this|mixed|null
     * @deprecated
     */
    public function __call($name, $arguments)
    {
        if (preg_match("#^set#Umis", $name)) {
            $name = lcfirst(substr($name, 3));

            $this->view->assign($name, $arguments[0]);

            return $this;
        }

        if (preg_match("#^get#Umis", $name)) {
            $name = lcfirst(substr($name, 3));

            if (!isset($this->view->$name)) {
                return null;
            }

            if (is_array($this->view->$name)) {
                return $this->view->$name[$arguments[0]];
            }

            return $this->view->$name;
        }

        if (preg_match("#^add#Umis", $name)) {
            $name = lcfirst(substr($name, 3));

            if (!isset($this->view->$name)) {
                $this->view->$name = array();
            }

            if (isset($arguments[1])) {
                $this->view->$name[$arguments[0]] = $arguments[1];
            } else {
                $var = &$this->view->$name;
                if (is_array($arguments[0])) {
                    $var = array_merge($var, $arguments[0]);
                } else {
                    $var[] = $arguments[0];
                }
            }

            return $this;
        }

        $className = ucfirst($name) . "Hui";
        $instance = new $className($this, $arguments);
        $instance->view = &$this->view;

        return $instance;
    } // end __call

    public function setTemplateName($templateName)
    {
        $this->templateName = $templateName;
    } // end setTemplateName

    public function fetch(): string
    {
        return $this->view->fetch('ui/'.$this->templateName);
    }


    public function getValue()
    {
        return isset($this->arguments[0]) ? $this->arguments[0] : false;
    } // end getValue

}