<?php

use ui\IInput;

/**
 * Class InputHui.
 */
class InputHui extends HuiComponent implements IInput
{
    public function fetch(): string
    {
        $type = $this->getType();

        $templateName = $type ? 'input_'.$type : 'input';
        
        return $this->view->fetch('ui/'.$templateName.'.php');
    }

    public function setCSS(string $css): IInput
    {
        $this->view->css = $css;

        return $this;
    }

    public function setName(string $name): IInput
    {
        $this->view->name = $name;

        return $this;
    }

    public function setType(string $name): IInput
    {
        $this->view->type = $name;

        return $this;
    }

    public function setValue(string $name): IInput
    {
        $this->view->value = $name;

        return $this;
    }

    public function getName(): string
    {
        return $this->view->name;
    }

    public function getType(): ?string
    {
        if (!isset($this->view->type)) {
            return null;
        }
    
        return $this->view->type;
    }
}