<?php

namespace engine;

class EngineError
{
    private \Throwable $_exp;
    private string $_message;
    private bool $_isOverride;

    public function __construct(\Throwable $exp)
    {
        $this->_exp = $exp;
        $this->_message = $exp->getMessage();
        $this->_isOverride = false;
    }

    public function setMessage(string $message): void
    {
        $this->_message = $message;
    }

    public function setOverride(bool $isOverride): void
    {
        $this->_isOverride = $isOverride;
    }

    public function isOverride(): bool
    {
        return $this->_isOverride;
    }

    public function getMessage(): string
    {
        return $this->_message;
    }

    public function getException(): \Throwable
    {
        return $this->_exp;
    }
}